﻿using IOBS2013;
using System;
using System.Linq;

namespace Landsbankinn.B2B.Sample.B2BIOBS2013
{
    class Client : B2BIOBSClient
    {
        public void DisplayCurrencyRates(DateTime date)
        {
            var client = new IcelandicOnlineBankingCurrencyRatesSoapClient(CreateBinding(), CreateEndpointAddress("IcelandicOnlineBankingCurrencyRates.svc"));
            SetupClientSecurity(client);

            try
            {
                var currencyRates = client.GetCurrencyRates(new CurrencyRatesQuery { CurrencyType = CurrencyType.ExchangeRate, Date = date } );

                Console.WriteLine(currencyRates.Where(x => x.CurrencyCode == "SEK").Select(x => $"{x.CurrencyCode} {x.BuyingRate} - {x.SellingRate}").FirstOrDefault());
            }
            catch (Exception ex)
            {
                Console.WriteLine($"Exception for {Endpoint}, {ex.Message}");
                if (ex.InnerException != null)
                {
                    Console.WriteLine("Inner exception " + ex.InnerException.Message);
                }
            }
        }
    }
}
